%define _confdir %{_sysconfdir}/swift

# The following values are provided by passing the following arguments
# to rpmbuild.  For example:
# 	--define "_version 1.0" --define "_release 1" --define "_name g4s"
#
%{!?_version:%define _version 2.3.0}
%{!?_name:%define _name swiftonfile}
%{!?_release:%define _release 3}

# The release version of original source tarball.
%{!?_base_release:%define _base_release 0}

Summary  : GlusterFS Integration with OpenStack Object Storage (Swift).
Name     : %{_name}
Version  : %{_version}
Release  : %{_release}%{?dist}
Group    : Application/File
URL      : http://github.com/gluster/gluster-swift
Vendor   : Red Hat, Inc.
Source0  : %{_name}-%{_version}-%{_base_release}.tar.gz
License  : ASL 2.0
BuildArch: noarch
BuildRequires: python
BuildRequires: python-setuptools
Requires : memcached
Requires : openssl
Requires : python
Requires : python-prettytable
Requires : openstack-swift = 2.3.0
Requires : openstack-swift-account = 2.3.0
Requires : openstack-swift-container = 2.3.0
Requires : openstack-swift-object = 2.3.0
Requires : openstack-swift-proxy = 2.3.0
# swiftonfile has no hard-dependency on particular version of glusterfs
# so don't bump this up unless you want to force users to upgrade their
# glusterfs deployment.
Requires : python-gluster >= 3.7.1
Obsoletes: gluster-swift
Obsoletes: gluster-swift-account
Obsoletes: gluster-swift-container
Obsoletes: gluster-swift-object
Obsoletes: gluster-swift-proxy
Obsoletes: gluster-swift-plugin
Obsoletes: glusterfs-swift-plugin
Obsoletes: glusterfs-swift
Obsoletes: glusterfs-ufo
Obsoletes: glusterfs-swift-container
Obsoletes: glusterfs-swift-object
Obsoletes: glusterfs-swift-proxy
Obsoletes: glusterfs-swift-account

Patch0001: 0001-Don-t-fetch-metadata-for-plain-container-listing.patch
Patch0002: 0002-Don-t-fetch-metadata-for-plain-object-listing.patch
Patch0003: 0003-Enhance-object-expiration.patch
Patch0004: 0004-Make-swift-s-expirer-compatible-with-gluster-swift.patch
Patch0005: 0005-Remove-redundant-syscalls-in-POST-path.patch
Patch0006: 0006-Open-object-only-if-it-s-going-to-be-read.patch
Patch0007: 0007-Handle-non-blocking-renames-during-object-PUTs.patch
Patch0008: 0008-Don-t-f-chown-when-it-has-no-effect.patch

%description
SwiftOnFile integrates GlusterFS as an alternative back end for
OpenStack Object Storage (Swift) leveraging the existing front end
OpenStack Swift code. Gluster volumes are used to store objects in files,
containers are maintained as top-level directories of volumes,
where accounts are mapped one-to-one to gluster volumes.

%prep
%setup -q

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1

%build
%{__python} setup.py build

%install
rm -rf %{buildroot}

%{__python} setup.py install -O1 --skip-build --root %{buildroot}

mkdir -p      %{buildroot}/%{_confdir}/
cp -r etc/*   %{buildroot}/%{_confdir}/

# Man Pages
install -d -m 755 %{buildroot}%{_mandir}/man8
for page in doc/man/*.8; do
    install -p -m 0644 $page %{buildroot}%{_mandir}/man8
done

# Remove tests
%{__rm} -rf %{buildroot}/%{python_sitelib}/test

# Remove files provided by python-gluster (glusterfs-api earlier)
%{__rm} -rf %{buildroot}/%{python_sitelib}/gluster/__init__.p*

%files
%defattr(-,root,root)
%{python_sitelib}/gluster
%{python_sitelib}/gluster_swift-%{_version}_*.egg-info
%{_bindir}/gluster-swift-gen-builders
%{_bindir}/gluster-swift-print-metadata
%{_bindir}/gluster-swift-migrate-metadata
%{_bindir}/gluster-swift-object-expirer
%{_bindir}/gswauth-add-account
%{_bindir}/gswauth-add-user
%{_bindir}/gswauth-cleanup-tokens
%{_bindir}/gswauth-delete-account
%{_bindir}/gswauth-delete-user
%{_bindir}/gswauth-list
%{_bindir}/gswauth-prep
%{_bindir}/gswauth-set-account-service
%{_mandir}/man8/*

%dir %{_confdir}
%config(noreplace) %{_confdir}/account-server.conf-gluster
%config(noreplace) %{_confdir}/container-server.conf-gluster
%config(noreplace) %{_confdir}/object-server.conf-gluster
%config(noreplace) %{_confdir}/swift.conf-gluster
%config(noreplace) %{_confdir}/proxy-server.conf-gluster
%config(noreplace) %{_confdir}/fs.conf-gluster
%config(noreplace) %{_confdir}/object-expirer.conf-gluster

%changelog
* Mon May 9 2016 Prashanth Pai <ppai@redhat.com> - 2.3.0-3
- Fixed: BZ #1312833, #1314171

* Thu Apr 21 2016 Prashanth Pai <ppai@redhat.com> - 2.3.0-2
- Fixed: BZ #1312812 (again)
         Enable using 'swift-init object-expirer start' on el7

* Sat Apr 16 2016 Prashanth Pai <ppai@redhat.com> - 2.3.0-1
- Fixed: BZ #1312812, #1312810

* Mon Mar 21 2016 Prashanth Pai <ppai@redhat.com> - 2.3.0-0
- Fixed: BZ #1302546, #1308849, #1314172, #1314622

* Tue Oct 6 2015 Prashanth Pai <ppai@redhat.com> - 1.13.1-6
- Fixed: BZ #1258752/CVE-2015-5242

* Fri Aug 28 2015 Prashanth Pai <ppai@redhat.com> - 1.13.1-5
- Fixed: BZ #1257884/CVE-2014-8177

* Tue Aug 25 2015 Prashanth Pai <ppai@redhat.com> - 1.13.1-4
- Fixed: BZ 1255308

* Wed Aug 19 2015 Prashanth Pai <ppai@redhat.com> - 1.13.1-3
- Fixed BZs: 1249989, 1250380, 1238116, 1251925, 1238147

* Thu Nov 20 2014 Prashanth Pai <ppai@redhat.com> - 1.13.1-2
- Bump version to 2. Retain upstream version

* Thu Nov 20 2014 Prashanth Pai <ppai@redhat.com> - 1.13.1-1
- Bump version to 1. Fix Requires issue

* Thu Nov 13 2014 Prashanth Pai <ppai@redhat.com> - 1.13.1-0
- Rebase to icehouse, include object expirer changes

* Thu Apr 17 2014 Luis Pabon <lpabon@redhat.com> - 1.10.0-6
- Upstream fixed functional tests to be able to run on RHEL/CentOS

* Wed Jan 15 2014 Chetan Risbud <crisbud@redhat.com> - 1.10.0-5
- Brought down latest fixes. Bumped the release to 5.

* Thu Jan 9 2014 Chetan Risbud <crisbud@redhat.com> - 1.10.0-4
- Brought down latest fixes. Bumped the release to 4.

* Fri Dec 20 2013 Chetan Risbud <crisbud@redhat.com> - 1.10.0-3
- Corrected gluster-swift requirements. Bumped release number to 3

* Tue Dec 17 2013 Chetan Risbud <crisbud@redhat.com> - 1.10.0-2
- Corrected glusterfs dep. bumped the release number.

* Thu Dec 12 2013 Chetan Risbud <crisbud@redhat.com> - 1.10.0-1
- Havana Release upstream broughtdown
